#!/usr/bin/perl -w

use strict;
use warnings;

my $sequenceFileDir  = "010_sequenceFileDir";
my $partitionFileDir = "010_partitionFileDir";
my $paraList         = "010_param.txt";

my $resultDir = "020_resDir";  ## Used in 020_autoResultMover.pl


opendir(DIR, $sequenceFileDir) or die "Cannot open $sequenceFileDir\n";
my @dirs = readdir(DIR);
close DIR;


#################################################
########### Check the presence of outputfile
my @selectedInfiles = ( );
my $count = 0;
foreach my $inFile (@dirs) {
  next if $inFile =~ /^\./;
  next if $inFile =~ /\.reduced/;
  push(@selectedInfiles, $inFile);
}


#################################################
########### Making job script

open(OUT, ">$paraList");

my $countA = 0;
foreach my $inFile (@selectedInfiles) {
  $countA++;

  ### Picking up the outgroup from each sequence file.
  open(IN, "$sequenceFileDir/$inFile");
  my @inFileCont = <IN>;
  close IN;
  my ($ref_fasHash,$ref_nameArray, $seqLength) = &phyHashReader(\@inFileCont);
  my $outgroup = $ref_nameArray->[0];

  print OUT "$inFile $outgroup\n";

}

close OUT;
exit;


#############################################

sub phyHashReader {
  my $name = "";
  my $seq = "";
  my @nameArray = ( );
  my %phyHash = ( );
  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine !~ /^\d/){
      ($name,$seq) = split(/ +/,$inFileLine);
      push(@nameArray,$name);
      $phyHash{$name} = $seq;
    }
  }
  return (\%phyHash,\@nameArray);
}
