#!/usr/bin/perl -w

use strict;
use warnings;

my $sequenceFileDir  = "010_sequenceFileDir";
my $partitionFileDir = "010_partitionFileDir";
my $paraList         = "010_param.txt";
my $jobScript        = "015_raxArraySLURM.slurm";

my $resultDir        = "020_resDir";


open(LIST, $paraList);
my @lines = <LIST>;
close LIST;

my @finished = ();
if(-d $resultDir){
  opendir(DIR, $resultDir);
  @finished = readdir(DIR);
  close DIR;
}
#print "finished @finished\n";

my $countB = 0;
my $numLine = "";
foreach my $line (@lines) {
  $countB++;
  chomp($line);
  $line =~ /^(\w*\.txt) /;
  my $fileName = $1;
  
  if(grep(/$fileName/,@finished)){
    print "$countB $fileName FOUND\n";
    next;
  }else{
    print "$countB $fileName NOT. Next\n";
  }

  if($countB == 1){
    $numLine .= $countB;
  }else{
    $numLine .= ",".$countB;  
  }
}

open(OUT, ">$jobScript");
my $scLine = &jobScript;
$scLine =~ s/NUMS/$numLine/;
print OUT "$scLine\n";

close OUT;
exit;


#############################################

sub jobScript {

my $scLineSR = '#!/bin/bash
#SBATCH --job-name=array_raxml
#SBATCH --partition=compute
#SBATCH --mem=2G
#SBATCH --cpus-per-task=2
#SBATCH --ntasks=1
#SBATCH --array=NUMS%240

tid=$SLURM_ARRAY_TASK_ID
params="$(head -$tid 010_param.txt | tail -1)"
param1=${params% *}
param2=${params#* }

raxmlHPC-PTHREADS-SSE3 -f a -x 12345 -p 12345 -# 100 -m GTRGAMMA -s 010_sequenceFileDir/$param1 -q 010_partitionFileDir/$param1 -o $param2 -n $param1 -T 2
';

return ($scLineSR);

}
